package polinomios;
/**
 *
 * @author Andrés Mella Romero
 */
//Clase que representa un término
public class Termino implements Comparable<Termino> {

    //El coeficiente del término
    private double coeficiente;
    //El exponente del término
    private int exponente;
    //La referencia al siguiente término
    private Termino siguiente;

    //Constructor que recibe sólo el coeficiente
    public Termino(double coeficiente) {
        //su exponente en cero
        this(coeficiente, 0);
    }

    //Constructor que recibe el coeficiente y el exponente
    public Termino(double coeficiente, int exponente) {
        this.coeficiente = coeficiente;
        this.exponente = exponente;
        this.siguiente = null;
    }
    //Método para establecer el coeficiente
    public double getCoeficiente() {
        return coeficiente;
    }
    //Método para obtener el coeficiente
    public void setCoeficiente(double coeficiente) {
        this.coeficiente = coeficiente;
    }
    //Método para obtener el exponente
    public int getExponente() {
        return exponente;
    }
    //Método para establecer el exponente   
    public void setExponente(int exponente) {
        this.exponente = exponente;
    }
    //Método para obtener la referenccia al siguiente término
    public Termino getSiguiente() {
        return siguiente;
    }
    //Método para establecer la referenccia al siguiente término
    public void setSiguiente(Termino siguiente) {
        this.siguiente = siguiente;
    }
    //Imprimir un término
    @Override
    public String toString() {

        StringBuilder sb = new StringBuilder();
        if (0d != coeficiente) {
            if (coeficiente > 0) {
                sb.append("+");
            }
            sb.append(coeficiente);
            switch (exponente) {
                case 0:
                    break;
                case 1:
                    sb.append("x");
                    break;
                default:
                    sb.append("x^");
                    sb.append(exponente);

            }

        }

        return sb.toString();
    }
    //Para ordenar el polinomio según sus exponentes
    @Override
    public int compareTo(Termino o) {
        if (o.getExponente() == this.exponente) {
            return 0;
        } else if (o.getExponente() > this.exponente) {
            return 1;
        } else {
            return -1;
        }
    }

}
